VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   885
   ClientLeft      =   60
   ClientTop       =   405
   ClientWidth     =   4065
   LinkTopic       =   "Form1"
   ScaleHeight     =   885
   ScaleWidth      =   4065
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Command1 
      Caption         =   "Command1"
      Height          =   675
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   3855
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Autor: F. Schler (frank@activevb.de)
' Datum: 11/2020
'
' Das ist nur ein Beispiel/Testcode! Fr entsprechende Infos zu den Interfaces, die
' hier im Beispiel verwendet werden, und wie das ganze funktioniert, bitte die
' Media Foundation Doku lesen!
'
' In diesem Beispiel wird nur das Prinzip gezeigt wie aus mehreren kleinen
' Bytearrays (Sample), die PCM-Daten enthalten, eine Audio-Datei erstellt werden kann.

Option Explicit

' Gre eines Standard WavHeader in Byte
Private Const WavHeaderSize As Long = 44

' Gre der Daten die stckchenweise konvertiert werden sollen.
Private Const SampleBuffSize As Long = 44100

' Maximale Gre des IMFMediaBuffer.
' Sollte mindestens SampleBuffSize * 2 oder grer sein
Private Const MaxBuffSize As Long = 88200

Private m_aWaveData() As Byte
Private m_bolMFInit As Boolean

Private Sub Form_Load()
    
    Dim FNr As Long
    
    m_bolMFInit = False
    
    ' Media Foundation starten
    If MFStartup(MF_VERSION, MF_STARTUP_FULL) = S_OK Then
    
        FNr = FreeFile
        
        ' Fr diese Demo muss die Wav-Datei eine PCM, 44.1kHz, 16bit, 2Ch
        ' mit einen Standard WavHeader (44 Byte) sein!
        Open App.Path & "\PCM_2Ch_16bit_44.1kHz.wav" For Binary Access Read As #FNr
        
            ' Gre des Arrays = Gre der Datei - WavHeader
            ReDim m_aWaveData((LOF(FNr) - WavHeaderSize) - 1)
            
            ' die PCM-Daten beginnen hinter dem WavHeader
            ' (Standard WavHeader = 44 Byte)
            Seek #FNr, WavHeaderSize + 1
            
            ' nur die PCM-Daten einlesen
            Get #FNr, , m_aWaveData
        
        Close FNr
    
        m_bolMFInit = True
        
    End If
    
End Sub

Private Sub Form_Unload(Cancel As Integer)

    ' Media Foundation beenden
    If m_bolMFInit = True Then Call MFShutdown

End Sub

Private Sub Command1_Click()

    Dim bolRet As Boolean
    Dim lngRest As Long
    Dim lngItem As Long
    Dim lngCount As Long
    Dim pIMFSample As Long
    Dim pIMFMediaBuffer As Long
    Dim pIMFSinkWriter As Long
    Dim lngStreamIndex As Long
    Dim aWaveData() As Byte
    
    bolRet = False
    
    ' ist die Media Foundation gestartet?
    If m_bolMFInit = True Then
    
        ' SampleBuffSize muss <= (MaxBuffSize \ 2) sein!!!
        If SampleBuffSize <= (MaxBuffSize \ 2) Then
    
            ' einen IMFSinkWriter fr MP3, ein IMFSample
            ' und ein IMFMediaBuffer erstellen
            If CreateWriter(App.Path & "\Output.mp3", pIMFSinkWriter, _
                lngStreamIndex, pIMFSample, pIMFMediaBuffer, _
                MaxBuffSize) = True Then
            
                
                
                ' Array fr die zu konvertierenden PCM-Daten
                ReDim aWaveData(SampleBuffSize - 1)
                
                ' Anzahl der Loops berechnen
                lngCount = (UBound(m_aWaveData) + 1) \ SampleBuffSize
                
                For lngItem = 0 To lngCount - 1

                    ' Daten von der geladenen Wav-Datei kopieren
                    ' Das sind unsere kleinen Samples die wir wieder
                    ' zu eine Audio-Datei zusammen setzen wollen.
                    Call CopyMemory(aWaveData(0), _
                        m_aWaveData(SampleBuffSize * lngItem), _
                        SampleBuffSize)

                    ' PCM-Daten (Sample) konvertieren / schreiben
                    If WriteSampleData(pIMFSinkWriter, pIMFSample, _
                        pIMFMediaBuffer, lngStreamIndex, aWaveData) = True Then
                        
                        bolRet = True
                    
                    Else

                        bolRet = False
                        
                        Exit For

                    End If

                Next lngItem
                
                
                
                ' weiter machen wenn bisher alles OK war
                If bolRet = True Then
                
                    ' Restdaten berechnen
                    lngRest = (UBound(m_aWaveData) + 1) Mod SampleBuffSize
                
                    ' nur wenn noch Restdaten vorhanden sind
                    If lngRest > 0 Then
                
                        ' Array fr die zu konvertierenden PCM-Daten
                        ReDim aWaveData(lngRest - 1)
                    
                        ' restliche Daten von der geladenen Wav-Datei kopieren
                        Call CopyMemory(aWaveData(0), m_aWaveData(UBound(m_aWaveData) - lngRest), lngRest)
                    
                        ' PCM-Daten konvertieren / schreiben
                        If WriteSampleData(pIMFSinkWriter, pIMFSample, _
                            pIMFMediaBuffer, lngStreamIndex, aWaveData) = True Then
                        
                            bolRet = True
                            
                        Else

                            bolRet = False
                            
                        End If
                
                    End If
                    
                End If
                
                
                
                ' weiter machen wenn bisher alles OK war
                If bolRet = True Then
                
                    ' schreiben in den IMFSinkWriter abschlieen
                    ' IMFSinkWriter, IMFSample und IMFMediaBuffer freigeben
                    If CloseWriter(pIMFSinkWriter, pIMFSample, _
                        pIMFMediaBuffer) = True Then
                    
                        bolRet = True
                        
                    Else
                    
                        bolRet = False
                        
                    End If
                    
                End If
                
                
                
            End If
                
        End If
    
    End If
            
    If bolRet = True Then
        
        MsgBox "Fertig, alles ok.", vbInformation
        
    Else
    
        MsgBox "Ups, da hat was nicht geklappt.", vbCritical
    
    End If
            
End Sub

